gtk-sharp 0.0.0.0 neutral Gtk# is thread aware, but not thread safe; See the Gtk# Thread Programming for details. A widget for displaying both trees and lists.

Widget that displays any object that implements the interface.

To create a tree or list in GTK#, you need to use the interface, in conjunction with the widget. This widget is designed around a Model/View/Controller design and consists of four major parts:

, the tree view widget
, the view column.
The cell renderers ( and others).
, the model interface.

The View is composed of the first three, while the last is the Model. One of the prime benefits of the MVC design is that multiple views can be created of a single model. For example, a model mapping the file system could be created for a file manager. Many views could be created to display various parts of the file system, but only one copy need be kept in memory.

The purpose of the cell renderers is to provide extensibility to the widget and to allow multiple ways of rendering the same type of data. For example, consider how to render a boolean variable. Should you render it as a string of "True" or "False", "On" or "Off", or should you render it as a checkbox?

A simple list: `using System; using Gtk; public class TreeViewSample { public static void Main (string [] args) { Application.Init (); TreeStore store = new TreeStore (typeof (string), typeof (string)); for (int i=0; i < 5; i++) { TreeIter iter = store.AppendValues ("Demo " + i, "Data " + i); } Window win = new Window ("TreeView List Demo"); win.DeleteEvent += new DeleteEventHandler (delete_cb); win.SetDefaultSize (400,250); ScrolledWindow sw = new ScrolledWindow (); win.Add (sw); TreeView tv = new TreeView (); tv.Model = store; tv.HeadersVisible = true; tv.AppendColumn ("Demo", new CellRendererText (), "text", 0); tv.AppendColumn ("Data", new CellRendererText (), "text", 1); sw.Add (tv); sw.Show (); win.ShowAll (); Application.Run (); } private static void delete_cb (System.Object o, DeleteEventArgs args) { Application.Quit (); args.RetVal = true; } }`

A more advanced example: `using System; using System.Reflection; using Gtk; public class TreeViewDemo { private static TreeStore store = null; private static Dialog dialog = null; private static Label dialog_label = null; public TreeViewDemo () { Application.Init (); PopulateStore (); Window win = new Window ("TreeView demo"); win.DeleteEvent += new DeleteEventHandler (DeleteCB); win.SetDefaultSize (640,480); ScrolledWindow sw = new ScrolledWindow (); win.Add (sw); TreeView tv = new TreeView (store); tv.HeadersVisible = true; tv.AppendColumn ("Name", new CellRendererText (), "text", 0); tv.AppendColumn ("Type", new CellRendererText (), "text", 1); sw.Add (tv); dialog.Destroy (); dialog = null; win.ShowAll (); Application.Run (); } private static void ProcessType (TreeIter parent, System.Type t) { foreach (MemberInfo mi in t.GetMembers ()) { store.AppendValues (parent, mi.Name, mi.ToString ()); } } private static void ProcessAssembly (TreeIter parent, Assembly asm) { string asm_name = asm.GetName ().Name; foreach (System.Type t in asm.GetTypes ()) { UpdateDialog ("Loading from {0}:\n{1}", asm_name, t.ToString ()); TreeIter iter = store.AppendValues (parent, t.Name, t.ToString ()); ProcessType (iter, t); } } private static void PopulateStore () { if (store != null) return; store = new TreeStore (typeof (string), typeof (string)); foreach (Assembly asm in AppDomain.CurrentDomain.GetAssemblies ()) { UpdateDialog ("Loading {0}", asm.GetName ().Name); TreeIter iter = store.AppendValues (asm.GetName ().Name, "Assembly"); ProcessAssembly (iter, asm); } } public static void Main (string[] args) { new TreeViewDemo (); } private static void DeleteCB (System.Object o, DeleteEventArgs args) { Application.Quit (); } private static void UpdateDialog (string format, params object[] args) { string text = String.Format (format, args); if (dialog == null) { dialog = new Dialog (); dialog.Title = "Loading data from assemblies..."; dialog.AddButton (Stock.Cancel, 1); dialog.Response += new ResponseHandler (ResponseCB); dialog.SetDefaultSize (480, 100); VBox vbox = dialog.VBox; HBox hbox = new HBox (false, 4); vbox.PackStart (hbox, true, true, 0); Gtk.Image icon = new Gtk.Image (Stock.DialogInfo, IconSize.Dialog); hbox.PackStart (icon, false, false, 0); dialog_label = new Label (text); hbox.PackStart (dialog_label, false, false, 0); dialog.ShowAll (); } else { dialog_label.Text = text; while (Application.EventsPending ()) Application.RunIteration (); } } private static void ResponseCB (object obj, ResponseArgs args) { Application.Quit (); System.Environment.Exit (0); } }`

For a example how to handle selection events see

Gtk.Container Atk.Implementor GLib.IWrapper GLib.IWrapper System.IDisposable
- Method
  System.Int32 `` Removes from . an object of type an object of type
- Method
  System.Void `` `` `` Sets a user function for determining where a column may be dropped when dragged. an object of type an object of type an object of type This function is called on every column pair in turn at the beginning of a column drag to determine where a drop can take place. If is set to be , then reverts to the default behavior of allowing all columns to be dropped everywhere.
- Method
  System.Void `` `` `` `` `` Moves the alignments of the to the position specified by and . an object of type an object of type an object of type an object of type an object of type

  If is , then no horizontal scrolling occurs. Likewise, if is no vertical scrolling occurs. At a minimum, one of or need to be non-. determines where the row is placed, and determines where the column is placed. Both are expected to be between 0.0 and 1.0. 0.0 means left/top alignment, 1.0 means right/bottom alignment, 0.5 means center.

  If is , then the alignment arguments are ignored, and the tree does the minimum amount of work to scroll the cell onto the screen. This means that the cell will be scrolled to the edge closest to its current position. If the cell is currently visible on the screen, nothing is done.

  This function only works if the model is set, and is a valid row on the model. If the model changes before the is realized, the centered path will be modified to reflect this change.

- Method
  Gdk.Pixmap `` This image is used for a drag icon. an object of type an object of type Creates a representation of the row at .
- Method
  System.Void Recursively collapses all visible and expanded nodes.
- Method
  System.Void `` `` Moves to be after to . an object of type an object of type If is , then is placed in the first position.
- Method
  System.Void `` `` `` Sets the current keyboard focus to be at , and selects it. an object of type an object of type an object of type This is useful when you want to focus the attention of the user on a particular row. If is not , then focus is given to the column specified by it. Additionally, if is specified, and is , then editing should be started in the specified cell. This function is often followed by in order to give keyboard focus to the widget. Please note that editing can only happen when the widget is realized.
- Method
  System.Void `` Fills with the currently-visible region of the buffer, in tree coordinates. an object of type Convert to widget coordinates with . Tree coordinates start at 0,0 for row 0 of the tree, and cover the entire scrollable area of the tree.
- Method
  System.Int32 `` `` This inserts the into the at . an object of type an object of type an object of type If is -1, then the is inserted at the end.
- Method
  System.Void `` `` Activates the cell determined by and . an object of type an object of type
- Method
  System.Boolean `` Returns if the node pointed to by is expanded. an object of type an object of type
- Method
  System.Void `` `` `` This function should almost never be used. It is meant for private use by ATK for determining the number of visible children that are removed when the user collapses a row, or a row is deleted. an object of type an object of type an object of type It is meant for private use by Atk for determining the number of visible children that are removed when the user collapses a row, or a row is deleted.
- Method
  System.Void `` `` `` Sets the compare function for the interactive search capabilities. The representing the node an object of type an object of type
- Method
  System.Void Disables the TreeView as a drag-and-drop destination.
- Method
  System.Int32 `` Appends to the list of columns. an object of type an object of type
- Method
  System.Void `` `` Sets the row that is highlighted for drag-and-drop feedback. an object of type , the path of the row to highlight, or null. an object of type , specifying whether to drop before, after, or into the row.
- Method
  System.Void Disables the TreeView as a drag source for automatic drag and drop actions.
- Method
  System.Boolean `` Collapses a row (hides its child rows, if they exist). an object of type an object of type
- Method
  System.Void Recursively expands all nodes.
- Method
  System.Void `` Calls the given function on all expanded rows. a to execute on every expanded row.
- Method
  System.Void `` `` Scrolls the such that the top-left corner of the visible area is , , where and are specified in tree window coordinates. an object of type an object of type The must be realized before this function is called. If it is not, you probably want to be using .
- Method
  Gtk.TreeViewColumn `` Gets the at the given position in the . an object of type an object of type
- Method
  System.Boolean `` `` Opens the row so its children are visible. an object of type an object of type an object of type
- Method
  System.Void Resizes all columns to their optimal width. Only works after the has been realized.
- Method
  System.Void Disposes the resources associated with the object.
- Constructor
  Internal constructor
  Pointer to the C object.
  An instance of TreeView, wrapping the C object.

  This is an internal constructor, and should not be used by user code.

- Constructor
  Creates a new object.
  an object of type
  This is the default constructor for
- Constructor
  Creates a new object.
  an object of type
  an object of type
  In this constructor the is set from .
- Property
  Gtk.TreeModel The model for the TreeView. an object of type an object of type
- Property
  Gtk.TreeSelection Gets the associated with the TreeView. an object of type
- Property
  Gdk.Window The window that this TreeView renders to. an object of type This property is primarily used to confirm that events on the TreeView are executed within the correct window.
- Property
  System.Boolean Whether to display alternating, shaded rows in the . an object of type an object of type Setting to sets a hint to the theme engine to draw rows in alternating colors.
- Property
  System.Boolean View allows user to search through columns interactively. an object of type an object of type
- Property
  System.Boolean Show the column header buttons. an object of type an object of type
- Property
  Gtk.TreeViewColumn Set the column for the expander column. an object of type an object of type
- Property
  System.Boolean View is reorderable. an object of type an object of type
- Property
  Gtk.Adjustment Horizontal Adjustment for the widget. an object of type an object of type
- Property
  System.Boolean Column headers respond to click events. an object of type an object of type
- Property
  Gtk.Adjustment Vertical Adjustment for the widget. an object of type an object of type
- Property
  System.Int32 Model column to search through when searching through code. an object of type an object of type
- Event
  Gtk.ScrollAdjustmentsSetHandler Fired whenever the scrollbar adjustment units are set.
- Event
  Gtk.RowExpandedHandler Fired whenever a row of the TreeView is expanded.
- Event
  Gtk.MoveCursorHandler Fired whenever the cursor is moved on this TreeView.
- Event
  Gtk.TestExpandRowHandler Fired when the widget wants to find out whether a row can be expanded or not.
- Event
  Gtk.SelectCursorRowHandler Fired when the row the cursor is on is selected.
- Event
  Gtk.RowCollapsedHandler Fired whenever a row is collapsed.
- Event
  System.EventHandler Fired when the columns of this tree change.
- Event
  Gtk.ExpandCollapseCursorRowHandler Fired when the row where the cursor is is expanded or collapsed.
- Event
  Gtk.RowActivatedHandler Fired when a row is activated; see .
- Event
  Gtk.TestCollapseRowHandler Fired when the system wants to know whether a particular row can be collapsed.
- Event
  System.EventHandler Fired when the cursor changes (rows).
- Method
  System.Boolean `` `` `` Finds the path at the point (x, y), relative to widget coordinates. an object of type an object of type an object of type an object of type It is primarily for things like popup menus. If is non-, then it will be filled with the at that point. If is non-, then it will be filled with the at that point. This function is only meaningful if TreeView is realized.
- Method
  System.Void `` `` `` `` Converts widget coordinates to coordinates for the tree window (the full scrollable area of the tree). an object of type an object of type an object of type an object of type
- Event
  Gtk.ToggleCursorRowHandler Fired when the cursor toggles a row. (FIXME: explain in more detail.)
- Event
  Gtk.StartInteractiveSearchHandler Fired when the user begins a search of the tree.
- Event
  Gtk.SelectAllHandler Fired whenever all rows of the TreeView are selected.
- Event
  Gtk.SelectCursorParentHandler Fired when the parent row of the current row is selected. (FIXME: explain in more detail.
- Event
  Gtk.UnselectAllHandler Fired whenever all rows of the TreeView are specifically deselected.
- Method
  Gtk.TreeViewColumn `` `` `` Adds a with a specific column title and attributes. column title cell renderer attributes The appended

  This function is used to append a new subclass with specific attributes to the .

  The following code sample will append a new to an existing and use column 0 from the as the text to render.

  `CellRendererText text = new CellRendererText (); tree_view.AppendColumn ("title", text, "text", 0);`

  This example illustrates how you can control the "editable" attribute of a column on a row-by-row basis.

  `TreeStore store = new TreeStore (typeof (string), typeof(bool)); /* add a column that will display the 'string' from the store */ /* note that we are binding the "text" value to column 0 of the store, and the "editable" value to the column 1 value of the store */ /* this enables per-row control over the editable flag, if desired */ tv.AppendColumn("My string", new CellRendererText(), "text", 0, "editable", 1); /* add a couple of rows to the treeview */ store.AppendValues("You can edit this", true); store.AppendValues("You can't edit this", false);`
- Method
  Gtk.TreeViewColumn `` `` `` Adds a new to the TreeView and returns it. a a a a This method actually creates the column, rather than relying on a column object to be passed in. There's an alternate invokation form if you'd like to pass in an existing column object.
- Method
  System.Void `` `` `` `` Sets the current keyboard focus to be on the given . This is useful for getting the user's attention to a particular row. a a a a

  If focus_column is not null, then focus is given to the column specified by it. If focus_column and focus_cell are not null, and focus_column contains 2 or more editable or activatable cells, then focus is given to the cell specified by focus_cell. Additionally, if focus_column is specified, and start_editing is null, then editing should be started in the specified cell.

  This function is often followed by(tree_view_obj) in order to give keyboard focus to the widget. Please note that editing can only happen when the widget is realized.

- Method
  System.Void `` Expands the treeview so the Path specified is visible. to expand to.
- Method
  System.Void `` `` Fills in path and focus_column with the current path and focus column. If the cursor isn't currently set, then path will point to null. If no column currently has focus, then focus_column will be null. ` a a The returned path must be freed with .
- Method
  System.Void `` `` Gets information about the row that is highlighted for feedback. a to put the highlighted path into. a to put the drop position into.
- Method
  System.Boolean `` `` `` `` Determines the destination row for a given XY position. This is used by drag-and-drop operations to determine the target rows for the action. a , the X coordinate a , the Y coordinate a to put the resulting destination row into. a to indicate where to put the dragged object, relative to the returned by this method. a
- Method
  System.Void `` `` `` `` Converts tree coordinates to widget coordinates. Tree coordinates start at 0,0 for row 0 of the tree, and cover the entire scrollable area of the tree. a , the X coordinate of the tree location a , the Y coordinate of the tree location a , the X coordinate for the widget a , the Y coordinate for the widget
- Constructor
  TreeView constructor
  a
  a
  Creates a with as its .
- Method
  System.Void `` `` `` Allows the TreeView to be used as a source for drag-and-drop actions. a , the mask of the allowed buttons for starting a drag a , a table of supported targets for dragging to a , what should be done with the dragged data.
- Method
  System.Void `` `` Turns this TreeView object into a destination for automatic drag-and-drop. a , a table of targets this TreeView will support. a , a bitmap of possible actions for a drag to this target
- Property
  GLib.GType GType Property. a Returns the native value for .
- Method
  GLib.GType Return the type of view mode being used for this TreeView. a FIXME: needs clarification.
- Method
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` `` Default handler for the event. a a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` `` `` Default handler for the event. a a a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` `` Default handler for the event. a a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean `` `` Default handler for the event. a a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Boolean Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Method
  System.Void `` `` Default handler for the event. a a Override this method in a subclass to provide a default handler for the event.
- Constructor
  Protected Constructor.
  a
  a
  Chain to this constructor if you have manually registered a native value for your subclass.
- Property
  Gtk.TreeViewColumn[] A list of all the columns currently in this TreeView. a
- Method
  Gdk.Rectangle `` `` Fills the bounding rectangle in tree window coordinates for the cell at the row specified by and the column specified by . a a a

  If is , or points to a path not currently displayed, the y and height fields of the rectangle will be filled with 0. If is , the x and width fields will be filled with 0. The sum of all cell rects does not cover the entire tree; there are extra pixels in between rows, for example. This function is only valid if is realized.

- Method
  Gdk.Rectangle `` `` Fills the bounding rectangle in tree window coordinates for the cell at the row specified by and the column specified by . a a a

  If is , or points to a node not found in the tree, the y and height fields of the rectangle will be filled with 0. If is , the x and width fields will be filled with 0. The returned rectangle is equivalent to the passed to . These background areas tile to cover the entire tree window (except for the area used for header buttons). Contrast with the , returned by , which returns only the cell itself, excluding surrounding borders and the tree expander area.

- Method
  System.Boolean `` `` `` `` `` `` Finds the path at the point (x, y), relative to widget coordinates. a , an x coordinate a , a y coordinate a to fill with the path at the (x,y) coordinate. a to fill with the column at the (x,y) coordinate. a to fill with the x coordinate relative to the cell background. a to fill with the y coordinate relative to the cell background. a , true if a row exists at (x,y).

  x and y must come from an event on the tree_view only where the event's window is the same as the window this TreeView renders to. It is primarily for things like popup menus. If path is non-null, then it will be filled with the GtkTreePath at that point. This path should be freed with . If column is non-NULL, then it will be filled with the column at that point.

  cell_x and cell_y return the coordinates relative to the cell background (i.e. the background_area passed to ). This function is only meaningful if the TreeView object is realized.

- Method
  System.Boolean `` `` `` `` Finds the path at the point (x, y), relative to widget coordinates. a , an x coordinate a , a y coordinate a to fill with the path at the (x,y) coordinate. a to fill with the column at the (x,y) coordinate. a , true if a row exists at (x,y) This is an alternate invocation form which doesn't return coordinates for the position relative to a cell's background.
- Property
  System.Boolean To be added a To be added
- Method
  System.Int32 `` `` `` `` `` `` To be added a a a a a a a To be added